#include<bits/stdc++.h>
#define FOR(i,a,b) for(int i = a; i < b; ++i)
#define FORD(i,a,b) for(int i = a; i >= b; --i)
#define pi pair<int, int>
#define ppi pair <pi, pi>
#define vi vector<int>
#define vvi vector<vi>
#define fi first
#define se second
#ifndef DEBUG
#define endl (char)10
#endif
using namespace std;
using ll = long long;
using ld = long double;

int mx = 51, my = 100001, ms = mx * my, s = (1<<18);
vector <int> L0(ms), L1(ms), S0(ms, 1), S1(ms, 1), T(ms, -1);
vector < vector <int> > M(mx, vector <int> (my));
vector <bool> B0(ms, false), W1(ms, false);
vector < vector <int> > Del(300000);
vector < set <int> > H(mx);

int get(int x, int y) { return M[x][y]; }

void init() {
	for (int i = 0; i < mx; i++) {
		for (int j = 0; j < my; j++) {
			M[i][j] = i * my + j;
			L0[M[i][j]] = L1[M[i][j]] = M[i][j];
			H[i].insert(j);
		}
	}
}

int find1(int x, vector <int> &L) { if (L[x] != x) L[x] = find1(L[x], L); return L[x];}

void union1(int x, int y, vector <int> &L, vector <int> &S) {
	int fx = find1(x, L), fy = find1(y, L);
	if (fx != fy) { if(S[fx] < S[fy]) swap(fx,fy); L[fy] = fx; S[fx] += S[fy]; }
}

void add_neighs(int x, int y, vector <int> &L, vector <int> &S, vector <bool> &B) {
	vector < pair <int,int> > V = {{x-1, y}, {x+1, y}, {x, y-1}, {x, y+1}};
	for (auto v : V)
		if (v.fi >= 0 && v.fi < mx && v.se >= 0 && v.se < my && B[get(v.fi, v.se)] == B[get(x, y)])
			union1(get(v.fi, v.se), get(x, y), L, S);
}

void update(int i, int y0, int y1, int iteration, vector <int> &L, vector <int> &S, vector <bool> &B) {
 auto it1 = H[i].lower_bound(y0);
 auto it2 = H[i].lower_bound(y1 + 1);	
 while(it1!=it2){
	 int val = (*it1), ind = get(i, val);
	 //cout << i << " " << y0 << " " << y1 << " " << iteration << " | " << i << " " << val <<endl;
	 T[ind] = iteration;
	 B[ind] = true;
	 Del[iteration].push_back(ind);
	 add_neighs(i, val, L, S, B);
	 it1=H[i].erase(it1);
 }
}

int main (){
	ios_base::sync_with_stdio(false); cout.tie(0); cin.tie(0);
	init();
	int ev, x0, y0, x1, y1, t;
	cin >> ev;
	vector <ppi> E(ev); vector <int> Ans(ev, -1);
	for (int i = 0; i < ev; i++) {
		cin >> t >> x0 >> y0 >> x1 >> y1;
		if (x0 > x1) {
			swap(x0, x1);
			swap(y0, y1);
		}
		if (x0 == x1 && y0 > y1)
			swap(y0, y1);
		E[i] = {{i, t}, {get(x0, y0), get(x1,y1)}};
		if (t == 0) {
			for (int x = x0; x <= x1; x++)
				update(x, min(y0, y1), max(y0, y1), i, L0, S0, B0);
		}
		else if (t == 1) {
		
			if (B0[get(x0, y0)]) {
				//cout << "t = 1 " << i <<endl;
				if (find1(get(x0, y0), L0) == find1(get(x1, y1), L0))
					Ans[i] = 1;
				else 
					Ans[i] = 0;
			}
		}
	}
	for (int i = 0; i < ms; i++) {
		W1[i] = !B0[i];
		if (W1[i]) {
			add_neighs(i / my, i % my, L1, S1, W1);
		}
	}
	for (int i = ev-1; i >= 0; i--) {
		t = E[i].fi.se;
		x0 = E[i].se.fi / my, y0 = E[i].se.fi % my;
		x1 = E[i].se.fi / my, y1 = E[i].se.fi % my;
		if (t == 0) {
			for (auto v : Del[i]) {
				W1[v] = true;
				add_neighs(v / my, v % my, L1, S1, W1);
			}
		}
		else if (t == 1) {
			if (Ans[i] == -1) {
				//cout << "t = 1 rev " << i <<endl;
				if (find1(get(x0, y0), L1) == find1(get(x1, y1), L1))
					Ans[i] = 1;
				else 
					Ans[i] = 0;
			}
		}
	}
	for (int i = 0; i < ev; i++)
		if (E[i].fi.se == 1)
			cout << (Ans[i] == 1 ? Ans[i] : 0) <<endl; 
	return 0;
}
